VERSION 5.00
Begin VB.Form frmMakeZipFiles 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Make Zip Files"
   ClientHeight    =   3180
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   4710
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   HasDC           =   0   'False
   KeyPreview      =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   212
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   314
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdMakeZipFiles 
      Caption         =   "Make &Zip Files"
      Height          =   1200
      Left            =   180
      TabIndex        =   0
      Top             =   990
      Width           =   4350
   End
End
Attribute VB_Name = "frmMakeZipFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function timeGetTime Lib "winmm.dll" () As Long

Implements IVBSAXContentHandler

Private m_AddExtraFiles   As Boolean
Private m_Complete        As Boolean
Private m_MismatchedFiles As Boolean
Private m_FileCount       As Long
Private m_App_Path        As String
Private m_ZipFileName     As String
Private WithEvents m_Zip  As cZipArchive
Attribute m_Zip.VB_VarHelpID = -1

Private Sub IVBSAXContentHandler_characters(strChars As String): End Sub

Private Sub IVBSAXContentHandler_endElement(strNamespaceURI As String, strLocalName As String, strQName As String)
    If strLocalName = "game" Then
        Select Case True
            Case m_Complete, m_MismatchedFiles
                If m_Zip.CompressArchive(m_ZipFileName) Then
                    m_FileCount = m_FileCount + 1&
                Else
                    MsgBox m_ZipFileName, vbCritical, m_Zip.LastError
                End If

                Set m_Zip = New cZipArchive     'Reset m_Zip.FileCount
        End Select
    End If
End Sub

Private Sub IVBSAXContentHandler_startElement(strNamespaceURI As String, strLocalName As String, strQName As String, ByVal oAttributes As MSXML2.IVBSAXAttributes)
    Dim EmptyBytes() As Byte

    Select Case strLocalName
        Case "rom"
            If m_Complete Then
                m_Zip.AddFile EmptyBytes, oAttributes.getValueFromName(vbNullString, "name")
            Else
                If m_MismatchedFiles Then
                    If m_AddExtraFiles Then
                        m_Zip.AddFile EmptyBytes, oAttributes.getValueFromName(vbNullString, "name")

                        If Int(Rnd * 4!) = 0! Then
                            m_Zip.AddFile EmptyBytes, "_" & oAttributes.getValueFromName(vbNullString, "name")
                        End If
                    Else
                        If Int(Rnd * 4!) Then
                            m_Zip.AddFile EmptyBytes, oAttributes.getValueFromName(vbNullString, "name")
                        End If
                    End If
                End If
            End If

        Case "game"
            m_ZipFileName = m_App_Path & "\" & oAttributes.getValueFromName(vbNullString, "name") & ".zip"
            m_Complete = -Int(Rnd * 2!)                 '50% chance of making a complete zip file

            If Not m_Complete Then                      '50% chance of making either a zip file with mismatching files or not making any at all
                m_MismatchedFiles = -Int(Rnd * 2!)      '25% chance of making a zip file with mismatching files

                If m_MismatchedFiles Then
                    m_AddExtraFiles = -Int(Rnd * 2!)    '50% chance of an extra file being added or a file being removed
                End If
            End If
    End Select
End Sub

Private Sub cmdMakeZipFiles_Click()
    Dim InIDE As Boolean, Start As Long, sText As String

    Debug.Assert Not Compiled(InIDE)

    m_App_Path = App.Path
    If InIDE Then m_App_Path = Left$(m_App_Path, InStrRev(m_App_Path, "\")) & "Test Folder"

    If LenB(Dir(m_App_Path & "\*.zip")) Then
        MsgBox "Delete the ZIP files in """ & m_App_Path & """ first!", vbInformation
        Exit Sub
    End If

    Start = timeGetTime
    m_FileCount = 0&
    MousePointer = vbHourglass
    Set m_Zip = New cZipArchive

    With New SAXXMLReader60
        Set .contentHandler = Me
        .putFeature "prohibit-dtd", False
        .parseURL m_App_Path & "\" & Dir(m_App_Path & "\*.dat")
    End With

    MousePointer = vbDefault
    cmdMakeZipFiles.Caption = "Making " & FormatNumber(m_FileCount, 0&) & " Zip Files took " & FormatNumber((timeGetTime - Start) / 1000&, 3&) & " seconds"
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyEscape Then Unload Me
End Sub

Private Sub Form_Load()
    Randomize
End Sub

Private Sub m_Zip_Error(ByVal FileIdx As Long, Source As String, Description As String, Cancel As Boolean)
    MsgBox "FileIdx = " & FileIdx & vbCr & _
           "Source = """ & Source & """" & vbCr & _
           "Description = """ & Description & """" & vbCr & _
           """" & m_ZipFileName & """", vbCritical
End Sub

Private Property Set IVBSAXContentHandler_documentLocator(ByVal RHS As MSXML2.IVBSAXLocator): End Property
Private Sub IVBSAXContentHandler_endDocument(): End Sub
Private Sub IVBSAXContentHandler_endPrefixMapping(strPrefix As String): End Sub
Private Sub IVBSAXContentHandler_ignorableWhitespace(strChars As String): End Sub
Private Sub IVBSAXContentHandler_processingInstruction(strTarget As String, strData As String): End Sub
Private Sub IVBSAXContentHandler_skippedEntity(strName As String): End Sub
Private Sub IVBSAXContentHandler_startDocument(): End Sub
Private Sub IVBSAXContentHandler_startPrefixMapping(strPrefix As String, strURI As String): End Sub

Private Function Compiled(ByRef InIDE As Boolean) As Boolean
    InIDE = True
End Function
