VERSION 5.00
Begin VB.Form frmSortZipFiles 
   Caption         =   "Sort Zip Files Demo"
   ClientHeight    =   6690
   ClientLeft      =   90
   ClientTop       =   420
   ClientWidth     =   9420
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   HasDC           =   0   'False
   KeyPreview      =   -1  'True
   LockControls    =   -1  'True
   ScaleHeight     =   446
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   628
   StartUpPosition =   2  'CenterScreen
   Begin VB.ListBox lstMismatchedFiles 
      Height          =   5805
      IntegralHeight  =   0   'False
      Left            =   6315
      TabIndex        =   7
      Top             =   780
      Width           =   3030
   End
   Begin VB.ListBox lstUnprocessed 
      Height          =   5805
      IntegralHeight  =   0   'False
      Left            =   3195
      TabIndex        =   5
      Top             =   780
      Width           =   3045
   End
   Begin VB.ListBox lstComplete 
      Height          =   5805
      IntegralHeight  =   0   'False
      Left            =   75
      TabIndex        =   3
      Top             =   780
      Width           =   3045
   End
   Begin VB.CommandButton cmdSort 
      Caption         =   "&Sort"
      Default         =   -1  'True
      Height          =   330
      Left            =   8130
      TabIndex        =   1
      Top             =   75
      Width           =   1215
   End
   Begin VB.TextBox txtPath 
      Height          =   330
      Left            =   75
      TabIndex        =   0
      Top             =   75
      Width           =   7965
   End
   Begin VB.Label Label 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Mismatched Files"
      Height          =   225
      Index           =   2
      Left            =   6315
      TabIndex        =   6
      Top             =   480
      UseMnemonic     =   0   'False
      Width           =   3045
   End
   Begin VB.Label Label 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Unprocessed"
      Height          =   225
      Index           =   1
      Left            =   3195
      TabIndex        =   4
      Top             =   480
      UseMnemonic     =   0   'False
      Width           =   3045
   End
   Begin VB.Label Label 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Complete"
      Height          =   225
      Index           =   0
      Left            =   75
      TabIndex        =   2
      Top             =   480
      UseMnemonic     =   0   'False
      Width           =   3045
   End
End
Attribute VB_Name = "frmSortZipFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type CDFH
    Signature         As Long       'Central directory file header signature = 0x02014B50
    VersionMadeBy     As Integer    'Version made by
    MinVersion        As Integer    'Version needed to extract (minimum)
    GPFlag            As Integer    'General purpose bit flag
    CompMethod        As Integer    'Compression method
    LastModTime       As Integer    'File last modification time
    LastModDate       As Integer    'File last modification date
    CRC32             As Long       'CRC-32
    CompSize          As Long       'Compressed size
    UncompSize        As Long       'Uncompressed size
    FileNameLen       As Integer    'File name length
    ExtraFieldLen     As Integer    'Extra field length
    FileCommentLen    As Integer    'File comment length
    DiskStart         As Integer    'Disk number where file starts
    IntFileAttribs    As Integer    'Internal file attributes
    ExtFileAttribs    As Long       'External file attributes
    LocalHeaderOffset As Long       'Relative offset of local file header
   'Filename          As String     'File name (variable length)
   'ExtraField        As String     'Extra field (variable length)
   'FileComment       As String     'File comment (variable length)
End Type

Private Type EOCD
    Signature      As Long       'End of central directory signature = 0x06054B50
    DiskNumber     As Integer    'Number of this disk
    CDStartDisk    As Integer    'Disk where central directory starts
    DiskCDRecords  As Integer    'Number of central directory records on this disk
    TotalCDRecords As Integer    'Total number of central directory records
    CDSize         As Long       'Size of central directory (in bytes)
    CDStartOffset  As Long       'Offset of start of central directory, relative to start of archive
    CommentLength  As Integer    'Comment length
   'Comment        As String     'Comment (variable length)
End Type

Private Declare Function SendMessageW Lib "user32.dll" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SysReAllocStringLen Lib "oleaut32.dll" (ByVal pBSTR As Long, Optional ByVal pszStrPtr As Long, Optional ByVal Length As Long) As Long
Private Declare Function timeGetTime Lib "winmm.dll" () As Long
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
Private Declare Sub PutMem4 Lib "msvbvm60.dll" (ByVal Addr As Long, ByVal NewVal As Long)

Implements IVBSAXContentHandler

Private m_FileNamesUB As Long
Private m_FileNames() As String
Private m_ZipFileName As String

Private Sub IVBSAXContentHandler_characters(strChars As String): End Sub

Private Sub IVBSAXContentHandler_endElement(strNamespaceURI As String, strLocalName As String, strQName As String)
    Const CDFH_SIGNATURE = &H2014B50, EOCD_SIGNATURE = &H6054B50, EFS = &H800           'EFS - Language encoding flag
    Dim FN As Integer, I As Long, J As Long, K As Long, Pos As Long
    Dim sFileName As String, CDFH As CDFH, EOCD As EOCD

    If strLocalName <> "game" Then Exit Sub

    FN = FreeFile
    sFileName = txtPath.Text
    sFileName = Left$(sFileName, InStrRev(sFileName, "\")) & m_ZipFileName              'Build a fully-qualified filename from the specified DatFile and ZIP filename
    On Error GoTo 1

    If (GetAttr(sFileName) And vbDirectory) <> vbDirectory Then                         'Must verify the zip file already exists because Open For Binary will create it if missing
        Open sFileName For Binary Access Read Lock Write As FN
            Pos = LOF(FN) + 1&                                                          'Must add 1 because the Get statement is 1-based

            For Pos = Pos - 22& To Pos - &H10015 Step -1&                               'Scan the file backwards starting from (LOF - EOCD min size) to (LOF - EOCD max size)
                Get FN, Pos, EOCD.Signature
                If EOCD.Signature = EOCD_SIGNATURE Then Exit For
            Next

            If EOCD.Signature = EOCD_SIGNATURE Then
                Get FN, Pos, EOCD
                Pos = EOCD.CDStartOffset + 1&                                           'Must add 1 because the Get statement is 1-based

                Do While EOCD.DiskCDRecords                                             'Examine all central directory records on this disk
                    Get FN, Pos, CDFH

                    If CDFH.Signature = CDFH_SIGNATURE Then
                        If (CDFH.ExtFileAttribs And vbDirectory) <> vbDirectory Then    'If not a folder
                            If (CDFH.GPFlag And EFS) = 0 Then                           'If filename (and comment) are in the original ZIP character encoding (IBM Code Page 437)
                                SysReAllocStringLen VarPtr(sFileName), , CDFH.FileNameLen
                                Get FN, Pos + 46&, sFileName
                            Else
                                                                                        'TODO: Add support for UTF-8 filenames
                            End If

                            I = InStrRev(sFileName, "/")                                'See if the filename contains a path
                            If I Then sFileName = Mid$(sFileName, I + 1&)               'If it does, strip the path from the filename

                            For I = m_FileNamesUB To 0& Step -1&                        'Scan the m_FileNames array backwards
                                If m_FileNames(I) = sFileName Then                      'and look for the filename
                                    If I < m_FileNamesUB Then                           'If the matching filename isn't at the end of the array
                                        J = StrPtr(m_FileNames(I))                      'Swap it with the last element
                                        K = StrPtr(m_FileNames(m_FileNamesUB))          'Note: swapping string pointers is faster than exchanging string data
                                        PutMem4 VarPtr(m_FileNames(m_FileNamesUB)), J
                                        PutMem4 VarPtr(m_FileNames(I)), K               'If the matching filename is at the end of the array however,
                                    End If                                              'simply exclude it from the active elements of the array

                                    m_FileNamesUB = m_FileNamesUB - 1&                  'Decrement m_FileNamesUB to simulate shrinking the array (this is faster than ReDim Preserve)
                                    Exit For                                            'Stop scanning once a match is found and the relevant array elements are rearranged
                                End If
                            Next

                            If I = -1& Then                                             'If zip file has a file not found in the DatFile,
                                lstMismatchedFiles.AddItem m_ZipFileName                'add it to the Mismatched Files list & quit searching
                                Exit Do
                            End If
                        End If

                        Pos = Pos + 46& + CDFH.FileNameLen + CDFH.ExtraFieldLen + CDFH.FileCommentLen
                        EOCD.DiskCDRecords = EOCD.DiskCDRecords - 1
                    Else
                        Err = vbObjectError
                        Exit Do                                                         'Abort searching the zip file if there is at least 1 invalid central directory signature
                    End If
                Loop

                If EOCD.DiskCDRecords = 0 Then
                    If m_FileNamesUB = -1& Then                                         'If the DatFile & zip file have exactly the same set of filenames,
                        lstComplete.AddItem m_ZipFileName                               'add the zip file to the Complete list
                    Else
                        lstMismatchedFiles.AddItem m_ZipFileName                        'If the DatFile has file(s) not found in the zip file,
                    End If                                                              'add the zip file to the Mismatched Files list
                End If
            Else
                Err = vbObjectError                                                     'Couldn't find the end of central directory signature; possibly corrupt Zip file
            End If
1       Close FN
    End If

    If Err Then lstUnprocessed.AddItem m_ZipFileName                                    'If searching was interrupted for any reason or if the DatFile has a game not
    On Error GoTo 0                                                                     'found in the specified folder, add the game filename to the Unprocessed list
    m_FileNamesUB = -1&                                                                 'Reset m_FileNamesUB
End Sub

Private Sub IVBSAXContentHandler_startElement(strNamespaceURI As String, strLocalName As String, strQName As String, ByVal oAttributes As MSXML2.IVBSAXAttributes)
    Const ALLOC_CHUNK = 50&
    Dim sFileName As String

    Select Case strLocalName
        Case "rom":     sFileName = oAttributes.getValueFromName(vbNullString, "name")

                        If m_FileNamesUB = UBound(m_FileNames) Then
                            ReDim Preserve m_FileNames(0& To m_FileNamesUB + ALLOC_CHUNK) As String     'Grow the array in chunks to avoid ReDim'ming frequently
                        End If

                        m_FileNamesUB = m_FileNamesUB + 1&                                              'Increment m_FileNamesUB to simulate expanding the array
                        m_FileNames(m_FileNamesUB) = sFileName

        Case "game":    m_ZipFileName = oAttributes.getValueFromName(vbNullString, "name") & ".zip"
    End Select
End Sub

Private Sub Form_Resize()
    Const GAP = 5! 'Pixels
    Dim LBHeight As Single, LBTop As Single, OneThird As Single

    On Error Resume Next

    OneThird = (ScaleWidth - GAP * 4!) / 3!
    txtPath.Move GAP, GAP, ScaleWidth - cmdSort.Width - GAP * 3!
    cmdSort.Move txtPath.Left + txtPath.Width + GAP, GAP

    Label(0).Move GAP, txtPath.Height + GAP + GAP, OneThird
    Label(1).Move OneThird + GAP + GAP, Label(0).Top, OneThird
    Label(2).Move OneThird * 2! + GAP * 3!, Label(1).Top, OneThird

    LBTop = Label(0).Top + Label(0).Height + GAP
    LBHeight = ScaleHeight - LBTop - GAP
    lstComplete.Move GAP, LBTop, OneThird, LBHeight
    lstUnprocessed.Move Label(1).Left, LBTop, OneThird, LBHeight
    lstMismatchedFiles.Move Label(2).Left, LBTop, OneThird, LBHeight
End Sub

Private Sub txtPath_Change()
    cmdSort.Enabled = LenB(txtPath.Text) > 0&
End Sub

Private Sub cmdSort_Click()
    Const WM_SETREDRAW = 11&
    Dim Start As Long, ErrNum As Long, ErrDesc As String

    Start = timeGetTime
    MousePointer = vbHourglass
    lstComplete.Clear
    lstUnprocessed.Clear
    lstMismatchedFiles.Clear
    lstComplete.Visible = False                             'SendMessageW lstComplete.hWnd, WM_SETREDRAW, False, 0&         'WM_SETREDRAW seems to be ignored by VB.ListBox
    lstUnprocessed.Visible = False                          'SendMessageW lstUnprocessed.hWnd, WM_SETREDRAW, False, 0&
    lstMismatchedFiles.Visible = False                      'SendMessageW lstMismatchedFiles.hWnd, WM_SETREDRAW, False, 0&

    With New SAXXMLReader60
        Set .contentHandler = Me                            'The prohibit-dtd feature is True by default for MSXML 6.0
       .putFeature "prohibit-dtd", False                    'Disable it so that SAXXMLReader60 won't complain about the DTD in "FB Alpha v0.2.97.30.dat"

        On Error Resume Next
       .parseURL txtPath.Text
        If Err Then ErrNum = Err: ErrDesc = Err.Description
        On Error GoTo 0
    End With

    lstComplete.Visible = True                              'SendMessageW lstComplete.hWnd, WM_SETREDRAW, -True, 0&
    lstUnprocessed.Visible = True                           'SendMessageW lstUnprocessed.hWnd, WM_SETREDRAW, -True, 0&
    lstMismatchedFiles.Visible = True                       'SendMessageW lstMismatchedFiles.hWnd, WM_SETREDRAW, -True, 0&
    m_FileNames = Split(vbNullString)                       'Reset the array to its initialized but empty state to reduce memory usage
    m_ZipFileName = vbNullString
    MousePointer = vbDefault

    If ErrNum = 0& Then
        Caption = "Sorting " & FormatNumber(lstComplete.ListCount + _
                  lstUnprocessed.ListCount + lstMismatchedFiles.ListCount, 0&) & _
                  " Zip Files took " & FormatNumber((timeGetTime - Start) / 1000&, 3&) & " seconds"
        Label(0).Caption = "Complete: " & FormatNumber(lstComplete.ListCount, 0&)
        Label(1).Caption = "Unprocessed: " & FormatNumber(lstUnprocessed.ListCount, 0&)
        Label(2).Caption = "Mismatched Files: " & FormatNumber(lstMismatchedFiles.ListCount, 0&)
    Else
        Caption = "Sort Zip Files Demo"
        Label(0).Caption = "Complete"
        Label(1).Caption = "Unprocessed"
        Label(2).Caption = "Mismatched Files"
        MsgBox ErrDesc, vbCritical, "Error &H" & Hex$(ErrNum)
    End If
End Sub

Private Sub Form_Activate()
    Const PROMPT = "No zip files found in ""Test Folder""" & vbCr & "Would you like to run "
    Dim InIDE As Boolean, MissingMakeZips As Boolean, App_Path As String, sText As String
    Dim oFolderItem As Object, oFolderItemVerbs As Object, oFolderItemVerb As Object

    Debug.Assert Not Compiled(InIDE)

    App_Path = App.Path
    If InIDE Then sText = "\Test Folder"

    If LenB(Dir(App_Path & sText & "\*.zip")) = 0& Then                                 'If there are no zip files in the Test Folder
        If Not InIDE Then
            On Error Resume Next

            If (GetAttr(App_Path & "\MakeZips.exe") And vbDirectory) = vbDirectory Then 'OERN + If statement causes execution to resume on
                MissingMakeZips = True                                                  'the next line if the expression raises an error
                sText = """Make Zip Files\prjMakeZipFiles.vbp"""
            Else
                sText = """MakeZips.exe"""
            End If

            On Error GoTo 0
        Else
            sText = """Make Zip Files\prjMakeZipFiles.vbp"""
        End If

        If MsgBox(PROMPT & sText & " first?", vbQuestion Or vbYesNo) = vbYes Then
            With CreateObject("Shell.Application")
                If Not InIDE Then
                    If Not MissingMakeZips Then
                        .ShellExecute App_Path & "\MakeZips.exe"
                    Else
                        App_Path = Left$(App_Path, InStrRev(App_Path, "\") - 1&)        'Trim off the "\Test Folder" path component
                        GoTo 1
                    End If
                Else
1                   Set oFolderItem = .NameSpace(App_Path & "\Make Zip Files").ParseName("prjMakeZipFiles.vbp")
                    Set oFolderItemVerbs = oFolderItem.Verbs

                    For Each oFolderItemVerb In oFolderItemVerbs
                        If oFolderItemVerb.Name = "Run" Then
                            oFolderItemVerb.DoIt                                        'InvokeVerb doesn't seem to work in Win 7
                            Exit For
                        End If
                    Next

                    If oFolderItemVerb Is Nothing Then
                        .ShellExecute oFolderItem.Path                                  'Fall back to default verb if Run isn't available (perhaps because it is localized)
                    End If
                End If
            End With
        End If
    End If
End Sub

Private Sub Form_Initialize()
    InitCommonControls
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyEscape Then Unload Me
End Sub

Private Sub Form_Load()
    Const LB_INITSTORAGE = &H1A8&
    Dim InIDE As Boolean

    m_FileNames = Split(vbNullString)                                   'Assign an initialized but empty array so that UBound will work
    m_FileNamesUB = -1&
    Debug.Assert Not Compiled(InIDE)
    m_ZipFileName = App.Path & IIf(InIDE, "\Test Folder\", "\")
    txtPath.Text = m_ZipFileName & Dir(m_ZipFileName & "*.dat")
    SendMessageW lstComplete.hWnd, LB_INITSTORAGE, 2000&, &H7EF40       '<-- 2000 items * MAX_PATH per item = 0.5 MB
    SendMessageW lstUnprocessed.hWnd, LB_INITSTORAGE, 2000&, &H7EF40
    SendMessageW lstMismatchedFiles.hWnd, LB_INITSTORAGE, 2000&, &H7EF40
End Sub

Private Property Set IVBSAXContentHandler_documentLocator(ByVal RHS As MSXML2.IVBSAXLocator): End Property
Private Sub IVBSAXContentHandler_endDocument(): End Sub
Private Sub IVBSAXContentHandler_endPrefixMapping(strPrefix As String): End Sub
Private Sub IVBSAXContentHandler_ignorableWhitespace(strChars As String): End Sub
Private Sub IVBSAXContentHandler_processingInstruction(strTarget As String, strData As String): End Sub
Private Sub IVBSAXContentHandler_skippedEntity(strName As String): End Sub
Private Sub IVBSAXContentHandler_startDocument(): End Sub
Private Sub IVBSAXContentHandler_startPrefixMapping(strPrefix As String, strURI As String): End Sub

Private Function Compiled(ByRef InIDE As Boolean) As Boolean
    InIDE = True
End Function
